#!/bin/sh
MODULEDIR=linux-wdist/modules/lib/modules/2.4.25
PCMCIADIR=pcmcia-cs-3.2.3/
NETDRIVERS=netdrivers-3.1/
HOSTAPMODULES=Prism2-2002-05-16/driver/modules
MADWIFIDIR=madwifi-cvs/madwifi

for f in modules/*.o modules/preferred/pcmcia/*.o; do
    mname=`echo $f | sed -e 's:.*/\(.*o\):\1:'`
    mlocation=`find $MODULEDIR/kernel -name $mname`
    if [ -n "$mlocation" ] ; then
	echo Copying $mlocation over $f ...
	cp -a -f $mlocation $f
    fi
done

for f in modules/*.o modules/preferred/pcmcia/*.o; do
    mname=`echo $f | sed -e 's:.*/\(.*o\):\1:'`
    mlocation=`find $PCMCIADIR -name $mname | grep -v compiled-modules`
    if [ -n "$mlocation" ] ; then
	echo Copying $mlocation over $f ...
	cp -a -f $mlocation $f
    fi
done

echo Copying pci-scan, rtl8139 drivers from $NETDRIVERS ...

cp -a -f $NETDRIVERS/rtl8139.o modules/
cp -a -f $NETDRIVERS/pci-scan.o modules/

echo Copying HostAP drivers ...

cp -a -f $HOSTAPMODULES/hostap_cs.o modules/preferred/pcmcia/
cp -a -f $HOSTAPMODULES/hostap_pci.o modules/
cp -a -f $HOSTAPMODULES/hostap_plx.o modules/

echo Copying Atheros drivers ...

cp -a -f $MADWIFIDIR/ath_hal/ath_hal.o modules/
cp -a -f $MADWIFIDIR/driver/ath_pci.o modules/
cp -a -f $MADWIFIDIR/wlan/wlan.o modules/

if [ -n "`find modules/ -size 0`" ] ; then 
    echo !! FATAL ERROR: Could not find compiled binaries for the following modules:
    find modules/ -size 0
    exit
fi
